<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../iron-ajax/iron-ajax.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../iron-icons/iron-icons.html">
<link rel="import" href="../app-layout/app-drawer/app-drawer.html">
<link rel="import" href="../paper-input/paper-input.html">


<dom-module id="dez-corpus">
  <template>
    <style>

    :host {
      display: block;
      font-size: 16px;
    }

    app-drawer {
      z-index: 10;
      --app-drawer-scrim-background: rgba(0, 0, 100, 0.8);
      --app-drawer-content-container: {
        background-color: #909EA5;
        color: #eee;
        padding-left: 15px;
        padding-right: 15px;
        min-width: 350px;
        overflow-y: scroll;
      }
    }

    h2 { font-weight: normal; }
    ul.pieces { list-style-type: none; padding: 0; }
    ul.pieces li { margin-top: 10px ; }
    ul.pieces li a { text-decoration: none; color: inherit; }
    ul.pieces li a:hover { color: white; }
    ul.pieces li span { font-size:smaller; display:block; }
    ul.pieces strong, ul.pieces strong span { opacity: 0.5; font-weight: inherit; }

    </style>

    <paper-icon-button icon="menu" title="load piece" on-tap="_toggleDrawer"></paper-icon-button>
    <app-drawer id="drawer" swipe-open on-tap="_closeDrawer">
      <h2>Dezrann</h2>
      <paper-input label="Search a piece" value="{{_filterString}}" on-value-changed="_filterCorpus"></paper-input>
      <ul class="pieces">
        <template is="dom-repeat" items="{{_filteredCorpus}}" as="piece" mutable-data>
          <li>
            <template is="dom-if" if="[[!piece.isCurrent]]">
              <a href="[[prefix]][[piece.id]]">
                [[piece.title]]
                <span>[[piece.composer]]</span>
              </a>
            </template>
            <template is="dom-if" if="[[piece.isCurrent]]">
              <strong>
                [[piece.title]]
                <span>[[piece.composer]]</span>
              </strong>
            </template>
          </li>
        </template>
      </ul>
      <p><a href="mailto:contact@dezrann.net?Subject=%5BDezrann%5D%20Add%20a%20piece&Body=%0ADear%20Dezrann%20team%2C%0A%0AWe%20would%20like%20to%20see%20and%20annotate%20the%20following%20pieces%20in%20Dezrann%20%3A%0A%20-%20...%0A%20-%20...%0A%0A%28Please%20provide%20also%20links%20to%20MusicXML%2C%20.krn%20or%20MIDI%20files%20of%20these%20pieces%29%0A%0A%0A%0A" style="color:inherit; text-decoration:none;"><iron-icon icon="add-box"></iron-icon> Add a piece</a></p>
    </app-drawer>

    <iron-ajax
      id="corpusLocationRequest"
      url="{{location}}"
      handle-as="json"
      debounce-duration="300"
      auto
      on-response="_corpusReady">
    </iron-ajax>

  </template>

  <script>
    /**
     * `dez-corpus`
     *
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */

     Array.prototype.sortOn = function(key){
        // from https://stackoverflow.com/a/16648532
        this.sort(function(a, b){
            if(a[key] < b[key]){
                return -1;
            }else if(a[key] > b[key]){
                return 1;
            }
            return 0;
        });
    }

    class DezCorpus extends Polymer.Element {

      static get is() { return 'dez-corpus'; }

      static get properties() {
        return {
          location: String,
          current: {
            type: String,
            observer: '_currentChanged'
          },
          prefix: {
            type: String,
            value: "/#/"
          }
        };
      }

      constructor () {
        super()
        this._filterString = ""
      }

      filterPiece(terms, piece) {
        let pieceTerms = piece.title.toUpperCase() + ' ' + piece.composer.toUpperCase()
        for (let term of terms.toUpperCase().split(' ')) {
          if (!pieceTerms.includes(term)) {
            return false
          }
        }
        return true
      }

      _filterCorpus (event, detail) {
        if (this._corpus == undefined) return
          this._filteredCorpus = this._corpus.filter(
              piece => this.filterPiece(detail.value, piece)
          );
      }

      _corpusReady (event) {
        this._corpus = event.detail.response.pieces
        this._currentChanged()
      }

      _currentChanged () {
        if (this._corpus != undefined) {
          this._corpus = this._corpus.map(piece => {
            piece.isCurrent = (piece.id == this.current)
            return piece;
          });
          this._corpus.sortOn("id")
          this._filteredCorpus = this._corpus.filter(
            piece => this.filterPiece(this._filterString, piece)
          )
        }
      }

      _toggleDrawer () {
        this.$.drawer.toggle();
      }

      _closeDrawer () {
        this.$.drawer.close();
      }

    }

    window.customElements.define(DezCorpus.is, DezCorpus);
  </script>
</dom-module>
